%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         sensu
%global repo            uchiwa
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          0.14.4
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global networking      0

Name:           %{repo}
Version:        %{commit}
Release:        1%{?dist}
Summary:        Uchiwa is a simple dashboard for the Sensu monitoring framework, built with Go and AngularJS.
License:        MIT
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
# Generated by:
# git clone https://github.com/sensu/uchiwa
# git checkout %{version}
# npm install --production && npm run postinstall
# tar -czf uchiwa-web-%{version}.tar.gz public
Source1:        uchiwa-web-%{version}.tar.gz
Source2:        uchiwa.service

BuildRequires:  systemd
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires:  golang(github.com/dgrijalva/jwt-go)
BuildRequires:  golang(github.com/gorilla/context)
BuildRequires:  golang(github.com/mitchellh/mapstructure)
BuildRequires:  golang(github.com/palourde/mergo)
BuildRequires:  golang(github.com/stretchr/objx)
BuildRequires:  golang(github.com/stretchr/testify)


Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
%{summary}

%prep
%setup -q -n %{repo}-%{commit}
rm -rf Godeps

%build
# set up temporary build gopath, and put our directory there
mkdir -p ./_build/src/github.com/sensu
ln -s $(pwd) ./_build/src/github.com/sensu/uchiwa

export GOPATH=$(pwd)/_build:%{gopath}
go build .

%install
mkdir -p %{buildroot}%{_bindir}
install uchiwa-%{version} %{buildroot}%{_bindir}/uchiwa

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE2} %{buildroot}%{_unitdir}/

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
cp config.json.example %{buildroot}%{_sysconfdir}/%{name}/uchiwa.json

install -d -p %{buildroot}/%{_datadir}/%{name}
tar -xzf %{SOURCE1} -C %{buildroot}/%{_datadir}/%{name}


%check
%if 0%{networking} > 0
export GOPATH=$(pwd)/_build:%{gopath}
go test ./uchiwa
%endif

%files
%defattr(-, uchiwa, uchiwa, -)
%doc CHANGELOG.md README.md LICENSE
%attr(0755, root, root) %{_bindir}/uchiwa
%{_unitdir}/uchiwa.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.json
%{_datadir}/%{name}

%pre
getent group uchiwa >/dev/null || groupadd -r uchiwa
getent passwd uchiwa >/dev/null || \
    useradd -r -g uchiwa -d /etc/uchiwa -s /sbin/nologin \
    -c "Uchiwa Sensu Web Interface" uchiwa
exit 0

%post
%systemd_post uchiwa.service
%preun
%systemd_preun uchiwa.service

%postun
%systemd_postun uchiwa.service

%changelog
* Fri May 13 2016 Martin Mágr <mmagr@redhat.com> - 0.14.4-1
- Updated to upstream version 0.14.4
- Simplified uchiwa-web build process

* Tue Jul 28 2015 Lon Hohberger <lon@redhat.com> - 0.8.0-2
- Fix permissions on /usr/bin/uchiwa

* Tue May 05 2015 Graeme Gillies <ggillies@redhat.com> - 0.8.0-1
- Update to version 0.8.0

* Mon Feb 02 2015 Graeme Gillies <ggillies@redhat.com> - 0.4.1-1
- First package for Fedora
